//+------------------------------------------------------------------+
//|                                                   10points 3.mq4 |
//|                              Copyright  2005, Alejandro Galindo |
//|                                              http://elCactus.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Alejandro Galindo"
#property link      "http://elCactus.com"

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern bool   EcnBroker                      = false;
extern string SymbolsPrefix                  = "";
extern string SymbolsSuffix                  = "";
extern bool   UseAutoMagic                   = true;
extern int    ManualMagic                    = 9191919191;  
extern double TakeProfit                     = 100;
extern double Lots                           = 0.01;
extern double InitialStop                    = 0;
extern int    TrailingStop                   = 20;
extern int    MinimumProfit                  = 10;
extern int    MaxTrades                      = 10;
extern int    Pips                           = 20;
extern int    slippage                       = 5;
extern int    SecureProfit                   = 5;
extern int    AccountProtection              = 1;
extern int    OrderstoProtect                = 3;
extern int    ReverseCondition               = 0;
extern bool   CloseOnTrendRev                = true;
extern int    bar                            = 1;

extern bool   mm                             = true;       // if True the lots size will increase based on account size (I don't recomend use MM with a martingale EA)
extern double risk                           = 0.1;        // risk to calculate the lots size (only if mm is enabled)
extern double lotincrease                    = 1.63;
extern bool   SpreadProtection               = true;       // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance                   = 5;          // value in pips over normal spread to activate the SpreadProtection.

extern string _acctprotect                   = "Account Protection";
extern double AccountEquityPercentProtection = 80;         // percent of the account Equity left to activate a hard stop loss on a set of trades.
extern int    HoursToRestart                 = 1;          // Hours need to restart after a Equity Stop Trigger.
extern bool   EquityTrailing                 = true;       // To enable a equity trail, it will close all orders when equity show profit
extern double PercentEquityTrailing          = 1;          // Percent of profit to start the closure off all the orders.

extern string _time                          = "Time Filter";
extern int    StartHour                      = 0;          // Start Hour of Trade Session 
extern int    StartMinute                    = 0;          // Start Minute of Trade Session 
extern int    EndHour                        = 23;         // End Hour of Trade Session
extern int    EndMinute                      = 0;          // End Hour of Trade Session

extern string OsMA_is                        = "OsMa Settings";

extern double OsMatf                         = 0;      //osma timeframe

extern int    FastEMA                        = 12;
extern int    SlowEMA                        = 26;
extern int    SignalSMA                      = 9;


extern string CenterofGravity_isv            = "Center of Gravity Settings";

extern double Cogtf1                         = 0;     //cog2 timeperiod
extern double Cogtf2                         = 0;      //cog2 2nd timeperiod

extern int    Per                            = 10;
extern int    Price                          = PRICE_MEDIAN;


extern string T3VhfPeriods_is                = "VHF Settings";
extern int    Length1                        = 14;
extern int    T3Period1                      = 5;
extern double T3Hot1                         = 1.0;
extern bool   T3Original1                    = true;
extern int    Length2                        = 7;
extern int    T3Period2                      = 5;
extern double T3Hot2                         = 1.0;
extern bool   T3Original2                    = true;

extern string _smi                           = "Smi Settings";
extern int    Length                         = 13;
extern int    Smooth1                        = 25;
extern int    Smooth2                        = 2;
extern int    Signal                         = 5;
extern int    SmiPrice                       = PRICE_CLOSE;

extern string __rsi                          = "Rsi Settings";
extern bool   UseRsiFilter                   = true;
extern int    UpLevel                        = 55;
extern int    DnLevel                        = 45;


//
//
//
//
//

int    cnt=0;
int    Magic;
int    lotsize,TriesNum = 5;
int    PreviousOpenOrders = 0;
int    myOrderType = 0,DontContinue;
int    TrendType = 0;
int    rsiTrend;
int    EquityStop,TimeStopTrigger;
int    GDrawdownTime, WaitingTime;

bool   ContinueOpening = True, AccountisNormal;

double sl = 0, tp = 0, StopTrading = 0, StopTrading2 = 0;
double DontStart = 0, DontStart2 = 1;
double BuyPrice = 0, SellPrice = 0;
double lotsi = 0, mylotsi = 0;
double LotStep;
double LastPrice = 0;
double MinLots = 0,MaxLots = 0;
double Spread,WorstSpread,NormalSpread;
double pipMultiplier = 1;
double EquityProtection;
double WorstDrawdown;
double AccEquity;

string s_symbol;
string text="", text2="",text3="", text4="", AccountText="", TrendTxt="";
string SmiEqFlag,EquityTrigger,MaxDrawdown,DrawdownTime,AccountEqty;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
  
   s_symbol = Symbol();
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic;
  
   NormalSpread = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,Digits%2);
   
   if (IsTesting())
         string nameAddition="testing-"+AccountNumber();
   else         nameAddition=AccountNumber();

   SmiEqFlag     = nameAddition+AccountNumber()+"_SmiEqFlag";     if (!GlobalVariableCheck(SmiEqFlag))     GlobalVariableSet(SmiEqFlag,0);
   AccountEqty   = nameAddition+AccountNumber()+"_AccountEqty";   if (!GlobalVariableCheck(AccountEqty))   GlobalVariableSet(AccountEqty,0);
   EquityTrigger = nameAddition+AccountNumber()+"_EquityTrigger"; if (!GlobalVariableCheck(EquityTrigger)) GlobalVariableSet(EquityTrigger,0);
   MaxDrawdown   = nameAddition+AccountNumber()+"_MaxDrawdown";   if (!GlobalVariableCheck(MaxDrawdown))   GlobalVariableSet(MaxDrawdown,0);
   DrawdownTime  = nameAddition+AccountNumber()+"_DrawdownTime";  if (!GlobalVariableCheck(DrawdownTime))  GlobalVariableSet(DrawdownTime,0);
   
   return(0);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit() 
{

if (IsTesting())
   {
      GlobalVariableDel(SmiEqFlag);
      GlobalVariableDel(AccountEqty);
      GlobalVariableDel(EquityTrigger);
      GlobalVariableDel(MaxDrawdown);
      GlobalVariableDel(DrawdownTime);
   }
   
return(0);  
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
  
      if (Digits==3 || Digits==5) 
            pipMultiplier = 10;
      else  pipMultiplier = 1;   
   
      double PipValue = MarketInfo(Symbol(),16);
      if (PipValue == 0) { PipValue = 5; }
      
      //
      //
      //
      //
      //
   
      Spread = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,Digits%2);   
   
      if (Spread > WorstSpread) WorstSpread = Spread;
      if (SpreadProtection && Spread > NormalSpread + PipTolerance) DontContinue = 1; else DontContinue = 0;
      
      if (UseRsiFilter) { trendFilter(); } 
   
      //
      //
      //
      //
      //
   
      GDrawdownTime   = GlobalVariableGet(DrawdownTime);
      WorstDrawdown   = GlobalVariableGet(MaxDrawdown);
      AccEquity       = GlobalVariableGet(AccountEqty);
      EquityStop      = GlobalVariableGet(SmiEqFlag);
      TimeStopTrigger = GlobalVariableGet(EquityTrigger);
   
      //
      //
      //
      //
      //
                
      if (AccountEquity()>AccEquity)
      {
         AccEquity = AccountEquity(); GlobalVariableSet(AccountEqty,AccEquity);
      } 
      
      int openedBuys   = 0;
      int openedSells  = 0;
      int openedOrders = countOpenedOrders(openedBuys,openedSells);
      
      if (openedOrders > 0 && EquityStop==1)
      {
         CloseAll(); return(0);
      } 
      if (openedOrders == 0)
      {
         GlobalVariableSet(AccountEqty,AccountEquity());
            if (EquityStop == 1) { EquityStop=0; GlobalVariableSet(SmiEqFlag,EquityStop); }
      }    

      //
      //
      //
      //
      //
      
      EquityProtection = NormalizeDouble((AccEquity * AccountEquityPercentProtection/100),2);
      if (AccountEquity() < EquityProtection) 
      {
         Alert("Closing orders because account equity protection was triggered. Balance: ",AccountBalance()," Equity: ", AccountEquity());
         EquityStop=1;                  
         TimeStopTrigger=TimeCurrent(); 
               GlobalVariableSet(SmiEqFlag,EquityStop);
               GlobalVariableSet(EquityTrigger,TimeStopTrigger);
         CloseAll();
         return(0);
      }
      
      //
      //
      //
      //
      //
      
      if (EquityTrailing == true && AccountEquity() >= AccountBalance()+(AccountBalance() * PercentEquityTrailing / 100)) 
      {
         Alert("Closing orders because account Equity Trailing was triggered. Balance: ",AccountBalance()," Equity: ", AccountEquity());	 
         EquityStop = 1;
            GlobalVariableSet(SmiEqFlag,EquityStop);
         CloseAll();
         return(0);
      }
      
      //
      //
      //
      //
      //
      
      double Drawdown = AccountEquity() - AccountBalance();
      if (Drawdown < WorstDrawdown)
      {
         WorstDrawdown = Drawdown;      GlobalVariableSet(MaxDrawdown, WorstDrawdown);
         GDrawdownTime = TimeCurrent(); GlobalVariableSet(DrawdownTime,GDrawdownTime);
      } 
    
      //
      //
      //
      //
      //
      
      if (TimeCurrent() <( TimeStopTrigger + HoursToRestart*3600))
            { WaitingTime = 1; }
      else  { WaitingTime = 0; }
   
   //
   //
   //
   //
   //        
   
   MinLots = NormalizeDouble(MarketInfo(Symbol(),23),2);
   LotStep = NormalizeDouble(MarketInfo(Symbol(),24),2);
   MaxLots = NormalizeDouble(MarketInfo(Symbol(),25),2); 
   lotsize = MarketInfo( Symbol(), MODE_LOTSIZE );
   
   if (lotsize == 100000) { AccountisNormal = True; } else {AccountisNormal = False;}
   if (lotsize == 10000)  { AccountisNormal = False; }
   
   if (AccountisNormal == True) { AccountText = "Standard"; } else { AccountText="Mini"; }
   
   //
   //
   //
   //
   //
     
   if (AccountisNormal)
   {
	  if (mm) 
	  { 
	   if (MinLots==1)    { lotsi=MathFloor(AccountBalance()*risk/100000);   }
	   if (MinLots==0.1)  { lotsi=MathFloor(AccountBalance()*risk/10000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/1000)/100; }
	  }
	   
	  else 
	  { 
		lotsi=Lots; 
	  }
	  
     } 
     else 
     {
       
     if (mm) 
	  { 
	   if (MinLots==1)    { lotsi=MathFloor(AccountBalance()*risk/10000);   }
	   if (MinLots==0.1)  { lotsi=MathFloor(AccountBalance()*risk/1000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/100)/100; }
	  } 
		else 
		{ 
		lotsi=Lots; 
		}
   }
   if (lotsi>MaxLots){ lotsi=MaxLots; }
   if (lotsi<MinLots){ lotsi=MinLots; }
   
   //
   //
   //
   //
   //
   
   if(BuyMarketCount(Symbol(),Magic) > 0 && TrailingStop > 0)
	{
		BuyTrailingStop(Symbol(),TrailingStop,MinimumProfit,Magic);
	}

   if(SellMarketCount(Symbol(),Magic) > 0 && TrailingStop > 0)
	{
		SellTrailingStop(Symbol(),TrailingStop,MinimumProfit,Magic);
	}
   
   //
   //
   //
   //
   //
   
   if (PreviousOpenOrders > openedOrders) 
   {	  
	  for(cnt = OrdersTotal(); cnt >= 0; cnt--)
	  {
	      int mode = OrderType();	
	      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()      != Symbol()) continue;
         if (OrderMagicNumber() != Magic)    continue; 
		   {
		   
			if (mode==OP_BUY)  { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage * Point * pipMultiplier,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage * Point * pipMultiplier, Red); }
			return(0);
		 }
	  }
   }
   
   //
   //
   //
   //
   //
   
   PreviousOpenOrders = openedOrders;
   if (openedOrders  >= MaxTrades) 
   {
   
	  ContinueOpening = False;
	  
   } else {
   
	  ContinueOpening = True;
   }
   
   //
   //
   //
   //
   //
   
   if (LastPrice == 0) 
   {
	  for(cnt = 0;cnt < OrdersTotal(); cnt++)
	  {
	    mode = OrderType();	
	    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
          if (OrderSymbol()      != Symbol()) continue;
          if (OrderMagicNumber() != Magic)    continue; 
		 {
			 LastPrice = OrderOpenPrice();
			 if (mode == OP_BUY)  { myOrderType = 2; }
			 if (mode == OP_SELL) { myOrderType = 1; }
		 }
	  }
   }
			
   //
   //
   //
   //
   //
   
   if (openedOrders < 1) 
   {
	   myOrderType=3;
	  
	  //BUY
	  //
	  //
	  //
	  //
	  
	  if (iCustom(NULL,OsMatf,"OsMA-1",FastEMA,SlowEMA,SignalSMA,0,bar)       >  iCustom(NULL,OsMatf,"OsMA-1",FastEMA,SlowEMA,SignalSMA,0,bar+1)
	  && iCustom(NULL,Cogtf1,"Ehlers Center of Gravity",Per,Price,true,0,bar) >  iCustom(NULL,Cogtf1,"Ehlers Center of Gravity",Per,Price,true,1,bar)
	  && iCustom(NULL,Cogtf2,"Ehlers Center of Gravity",Per,Price,true,0,bar) >  iCustom(NULL,Cogtf2,"Ehlers Center of Gravity",Per,Price,true,1,bar)
	  && iCustom(NULL,0,"T3_VHF",Length1,T3Period1,T3Hot1,T3Original1,0,bar)  >  iCustom(NULL,0,"T3_VHF",Length1,T3Period1,T3Hot1,T3Original1,0,bar+1) 
	  && iCustom(NULL,0,"T3_VHF",Length2,T3Period2,T3Hot2,T3Original2,0,bar)  >  iCustom(NULL,0,"T3_VHF",Length2,T3Period2,T3Hot2,T3Original2,0,bar+1)
	  && iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar)   >  iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar+1) 
	  && iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar)   >= -50 
	  && iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar)   <  0) { myOrderType = 2; TrendType = 2; } 
	  
	  //SELL
	  //
	  //
	  //
	  //
	  
	  if (iCustom(NULL,OsMatf,"OsMA-1",FastEMA,SlowEMA,SignalSMA,0,bar)       <  iCustom(NULL,OsMatf,"OsMA-1",FastEMA,SlowEMA,SignalSMA,0,bar+1)
	  && iCustom(NULL,Cogtf1,"Ehlers Center of Gravity",Per,Price,true,0,bar) <  iCustom(NULL,Cogtf1,"Ehlers Center of Gravity",Per,Price,true,1,bar)
	  && iCustom(NULL,Cogtf2,"Ehlers Center of Gravity",Per,Price,true,0,bar) <  iCustom(NULL,Cogtf2,"Ehlers Center of Gravity",Per,Price,true,1,bar)
	  && iCustom(NULL,0,"T3_VHF",Length1,T3Period1,T3Hot1,T3Original1,0,bar)  >  iCustom(NULL,0,"T3_VHF",Length1,T3Period1,T3Hot1,T3Original1,0,bar+1) 
	  && iCustom(NULL,0,"T3_VHF",Length2,T3Period2,T3Hot2,T3Original2,0,bar)  >  iCustom(NULL,0,"T3_VHF",Length2,T3Period2,T3Hot2,T3Original2,0,bar+1)
	  && iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar)   <  iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar+1) 
	  && iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar)   <= 50 
	  && iCustom(NULL,0,"SMI",Length,Smooth1,Smooth2,Signal,SmiPrice,0,bar)   >  0) { myOrderType = 1; TrendType = 1; } 
	  
	  //
	  //
	  //
	  //
	  //
	   
	  if (ReverseCondition==1)
	  {
	  	  if (myOrderType==1) { myOrderType=2; }
		  else { if (myOrderType==2) { myOrderType=1; } }
	  }
   }
   
   //
   //
   //
   //
   //
   
   
   int LastTicket        = 0;
   int LastType          = 0;
   double Profit         = 0;
	double LastClosePrice = 0;
	double LastLots       = 0;	
		
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
          if (OrderSymbol()      != Symbol()) continue;
          if (OrderMagicNumber() != Magic)    continue;
	  {			
	  	   
			if (OrderType()==OP_BUY)  { LastType = OP_BUY;  }
			if (OrderType()==OP_SELL) { LastType = OP_SELL; }
			LastTicket     = OrderTicket();
			LastClosePrice = OrderClosePrice();
			LastLots       = OrderLots();
			
			if (LastType == OP_BUY) 
				
			{ Profit = OrderProfit() + OrderSwap(); text2  = "Profit: $"+DoubleToStr(Profit,2); }
					
				
			
			if (LastType==OP_SELL) 
		 
			{ Profit = OrderProfit() + OrderSwap(); text2  = "Profit: $"+DoubleToStr(Profit,2); }
							
		
	//
	//
	//
	//
	//
	
   if (openedOrders >= (MaxTrades - OrderstoProtect) && AccountProtection == 1) 
   {	    
	     if (Profit >= SecureProfit) 
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage * Point * pipMultiplier,Yellow);		 
	        ContinueOpening=False;
	        return(0);
	     }
    }
    
    //
    //
    //
    //
    //
    
    if (CloseOnTrendRev)
	  	  {
	  	    if (myOrderType == 1 && TrendType != 2 && Profit >= SecureProfit) 
	  	      {
	  	      
	          CloseAll();
	          ContinueOpening = False;
		       myOrderType = 0;
		       
		       return(0);
		      }
		      
	  	    if (myOrderType == 2 && TrendType != 1 && Profit >= SecureProfit) 
	  	      {
	  	      
	          CloseAll();
	          ContinueOpening = False;
		       myOrderType = 0;
		       
		      return(0);
		   }
		 }
	  }   
   }
   
   //
   //
   //
   //
   //
   
   if (!IsTesting()) 
   {
        
	   if (myOrderType == 3) { text = "No conditions to open trades"; }
	     
	   else { text="    "; }
	     
	   Comment(" Account Type: ",AccountText,"\nLastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\nLots=",lotsi,"\n",text,"\nNormal Spread=",
	             NormalSpread,"\nActual Spread=",Spread,"\nWorst Spread=",WorstSpread,"\n",text2,"\n",text3,"\n",text4,"\nDaily RSI Trend : ",TrendTxt); 
      }
      
      //
      //
      //
      //
      //

      if (myOrderType == 1 && ContinueOpening && DontContinue == 0 && TimeCondition() && rsiTrend != 1)
      {
      
	     if ((Bid - LastPrice) >= Pips * Point * pipMultiplier || openedOrders < 1) 
	     {		
		    double SellPrice = Bid;				
		           LastPrice = 0;
		    
		    if (TakeProfit == 0)  { tp = 0; }
		    else { tp=SellPrice - TakeProfit * Point * pipMultiplier; }
		    	
		    if (InitialStop == 0) { sl = 0; }
		    else                  { sl = NormalizeDouble(SellPrice + InitialStop * Point * pipMultiplier + (MaxTrades - openedOrders) * Pips * Point * pipMultiplier,Digits);  }
		    
		    if (openedOrders != 0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt <= openedOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi = NormalizeDouble(mylotsi * 1.5,2        ); }
				     else              { mylotsi = NormalizeDouble(mylotsi * lotincrease,2); }
			      }
			      
		    } else { mylotsi = lotsi; }
		    if (mylotsi > 100) { mylotsi = 100; }
		    
		    //
		    //
		    //
		    //
		    //
		    
		    if (!EcnBroker)
   		       OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage * Point * pipMultiplier,sl,tp,"smi sell",Magic,0,Red);		    		    
          else
             {
                int sellTicket = OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage * Point * pipMultiplier,0,0,"smi sell",Magic,0,Red);		    		    
                if (sellTicket >= 0)
                     OrderModify(sellTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
             }		       
		    return(0);
	     }
      }
      
      //
      //
      //
      //
      //
      
      if (myOrderType == 2 && ContinueOpening && DontContinue == 0 && TimeCondition() && rsiTrend != 2) 
      {
	     if ((LastPrice - Ask) >= Pips * Point * pipMultiplier || openedOrders < 1) 
	     {		
		    double BuyPrice  = Ask;
		           LastPrice = 0;
		    
		    if (TakeProfit  == 0) { tp = 0; }
		    else                  { tp = BuyPrice + TakeProfit * Point * pipMultiplier; }
		    	
		    if (InitialStop == 0) { sl = 0; }
		    else                  { sl = NormalizeDouble(BuyPrice - InitialStop * Point * pipMultiplier - (MaxTrades - openedOrders) * Pips * Point * pipMultiplier,Digits); }
		    
		    if (openedOrders != 0) 
		    {
			   mylotsi = lotsi;
			   			
			   for(cnt = 1; cnt <= openedOrders; cnt++)
			   {
				  if (MaxTrades > 12) { mylotsi = NormalizeDouble(mylotsi * 1.5,2); }
				  else                { mylotsi = NormalizeDouble(mylotsi * lotincrease,2); }
			   }
		    } else { mylotsi = lotsi; }
		    if (mylotsi > 100) { mylotsi = 100; }
		    
		    //
		    //
		    //
		    //
		    //
		    
		    if (!EcnBroker)
   		       OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage * Point * pipMultiplier,sl,tp,"smi buy",Magic,0,Blue);		    
          else
             {
                int buyTicket = OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage * Point * pipMultiplier,0,0,"smi buy",Magic,0,Blue);
                if (buyTicket >= 0)
                     OrderModify(buyTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
             }		       
		    return(0);
	     }
      }   

   return(0);
  }
  
//
//
//
//
//

int trendFilter()
{

      double rsi  = iRSI(NULL,PERIOD_D1,20,PRICE_CLOSE,0);
      double rsi1 = iRSI(NULL,PERIOD_D1,20,PRICE_CLOSE,1);
      double rsi2 = iRSI(NULL,PERIOD_D1,20,PRICE_CLOSE,2);
   
      rsiTrend = 0;
      if (rsi < rsi1 && rsi1 < DnLevel && rsi2 <= DnLevel) { rsiTrend = 1; } //downtrend
      if (rsi > rsi1 && rsi1 > UpLevel && rsi2 >= UpLevel) { rsiTrend = 2; }
      
      if (rsiTrend   == 0) { TrendTxt = "Undefined - Ranging"; }
      if (rsiTrend   == 1) { TrendTxt = "Downtrend"; }
      if (rsiTrend   == 2) { TrendTxt = "Uptrend"; }
      
return(rsi);      
}

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd; 
        
   else
   
   if (StartHour > EndHour)
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24) || (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
   return(result);
}  

//----------------------------------------------------------------------------------------
//       orders counters
//----------------------------------------------------------------------------------------
//
//
//
//
//

int countOpenedOrders(int& openedBuys,int& openedSells)
{
   int openedOrders = 0;   
       openedBuys   = 0;
       openedSells  = 0;
   
   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
   
      //
      //
      //
      //
      //
      
      if(OrderSymbol() != Symbol()) continue;
  
      
         if(OrderType() == OP_BUY)  openedBuys++; 
         if(OrderType() == OP_SELL) openedSells++;
      
      if(OrderMagicNumber() != Magic) continue;
                  
      //
      //
      //
      //
      //
                  
      if(OrderType() == OP_BUY || OrderType() == OP_SELL) { openedOrders++; }
   }      
   return(openedOrders);
}

//
//
//
//
//

//
//
//
//
//

void BuyTrailingStop(string argSymbol, int argTrailingStop, int argMinProfit, int argMagicNumber)
	{
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
			{
				OrderSelect(Counter,SELECT_BY_POS);

				// Calculate Max Stop and Min Profit
				double MaxStopLoss = MarketInfo(argSymbol,MODE_BID) - (argTrailingStop * Point*pipMultiplier);
				MaxStopLoss = NormalizeDouble(MaxStopLoss,MarketInfo(OrderSymbol(),MODE_DIGITS));
				
				double CurrentStop = NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));

				double PipsProfit = MarketInfo(argSymbol,MODE_BID) - OrderOpenPrice();
				double MinProfit = argMinProfit * Point*pipMultiplier;

				// Modify Stop
				if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_BUY && CurrentStop < MaxStopLoss && PipsProfit >= MinProfit)
					{
						bool Trailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);

						// Error Handling
						if(Trailed == false)
							{
								int ErrorCode = GetLastError();
								string ErrDesc = ErrorDescription(ErrorCode);

								string ErrAlert = StringConcatenate("Buy Trailing Stop - Error ",ErrorCode,": ",ErrDesc);
								Alert(ErrAlert);

								string ErrLog = StringConcatenate("Bid: ",MarketInfo(argSymbol,MODE_BID)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",MaxStopLoss);
								Print(ErrLog);
							}
				}			
		}
}
	
//
//
//
//
//	
	
void SellTrailingStop(string argSymbol, int argTrailingStop, int argMinProfit, int argMagicNumber)
	{
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
			{
				OrderSelect(Counter,SELECT_BY_POS);

				// Calculate Max Stop and Min Profit
				double MaxStopLoss = MarketInfo(argSymbol,MODE_ASK) + (argTrailingStop * Point*pipMultiplier);
				MaxStopLoss = NormalizeDouble(MaxStopLoss,MarketInfo(OrderSymbol(),MODE_DIGITS));
				
				double CurrentStop = NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));

				double PipsProfit = OrderOpenPrice() - MarketInfo(argSymbol,MODE_ASK);
				double MinProfit = argMinProfit * Point*pipMultiplier;

				// Modify Stop
				if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_SELL && (CurrentStop > MaxStopLoss || CurrentStop == 0) && PipsProfit >= MinProfit)
					{
						bool Trailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);

						// Error Handling
						if(Trailed == false)
							{
								int ErrorCode = GetLastError();
								string ErrDesc = ErrorDescription(ErrorCode);

								string ErrAlert = StringConcatenate("Sell Trailing Stop - Error ",ErrorCode,": ",ErrDesc);
								Alert(ErrAlert);

								string ErrLog = StringConcatenate("Ask: ",MarketInfo(argSymbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",MaxStopLoss);
								Print(ErrLog);
							}
				}			
		}
}

//
//
//
//
//

//
//
//
//
//

int BuyMarketCount(string argSymbol, int argMagicNumber)
	{
		int OrderCount;
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
			{
				OrderSelect(Counter,SELECT_BY_POS);
				if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_BUY)
					{
						OrderCount++;
					}
			}
		return(OrderCount);
	}
	
//
//
//
//
//
	
int SellMarketCount(string argSymbol, int argMagicNumber)
	{
		int OrderCount;
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
			{
				OrderSelect(Counter,SELECT_BY_POS);
				if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_SELL)
					{
						OrderCount++;
					}
			}
		return(OrderCount);
	}
	
//
//
//
//
//

void CloseAll()
{
   if (!IsTradeAllowed()) return;

   Comment("\nEquity Closure Triggered, We will close all trades on every pair.");

   //
   //
   //
   //
   //
   
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() != Magic)   continue;

      string closingWhat = "";
         if (OrderType() == OP_BUY)  closingWhat = "BUY";
         if (OrderType() == OP_SELL) closingWhat = "SELL";
         if (closingWhat=="") continue;
               
      //
      //
      //
      //
      //
                     
      for(int c=0; c < TriesNum; c++)
      {
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage * Point * pipMultiplier,Yellow);
         int err=GetLastError();
         if (err==0) break;
      
            //
            //
            //
            //
            //
               
            Print("Errors Closing "+closingWhat+"order");
            Print(ErrorDescription(err),", error ",err);
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
            {
               Sleep(5000);
               continue;
            }  
         break;
      }               
   }       
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(91911921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(91911922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(91911931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(91911932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(91911941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(91911942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(91911951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(91911961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(91911962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(91911963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(91911964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(91911965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(91911966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(91911967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(91911971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(91911972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(91911973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(91911981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(91911982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(91911983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(91911991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(91911992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(91911993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(91911994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(9191195);
   
   //
   //
   //    some other symbol, use manual magic number
   //
   //
   
   return(ManualMagic);
}

